###############################################################################
# AwardSettings.pm                                                            #
###############################################################################
# Member Awards Admin                                                         #
# Author: Derek Barnstorm                                                     #
# Updated to 2.7.00 by Deborah Rorabaugh (Dandello)                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$awardsettingsplver = 'YaBB 2.7.00 $Revision: 0.3 $';
if ($action eq 'detailedversion') { return 1; }

if (!-e("$vardir/Mods/AwardSettings.txt")) { Awards2(); }
require "$vardir/Mods/AwardSettings.txt";

LoadLanguage('Mods/Awards');

sub Awards {
    is_admin_or_gmod();

    if ($en_awards)      { $chk_awards = qq~ checked="checked"~; }
    if ($en_awards_gmod) { $chk_awards_gmod = qq~ checked="checked"~; }
    if ($en_awards_tab)  { $chk_awards_tab = qq~ checked="checked"~; }
    if ($en_awards_mv)   { $chk_awards_mv = qq~ checked="checked"~; }
    if ($en_awards_im)   { $chk_awards_im = qq~ checked="checked"~; }

    $awards_name = "$award_txt{'39'}" if $awards_name eq q{};
    $awards_imsubject = "$award_txt{'44'}" if $awards_imsubject eq q{};
    $awards_imtext = "$award_txt{'45'}" if $awards_imtext eq q{};
    $awards_imtext =~ s~<br />~\n~g;

    fopen(AWARDS, "<$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    @mem_awards = <AWARDS>;
    fclose(AWARDS);

    $total_awards = @mem_awards || 0;

    if (@mem_awards) {
        $show_awards = qq~
<tr class="catbg" style="font-weight: bold; font-size: 11px;">
    <td>$award_txt{'26'}</td>
    <td>$award_txt{'02'}</td>
    <td>$award_txt{'01'}</td>
    <td>$award_txt{'07'}</td>
    <td>$award_txt{'27'}</td>
    <td>$award_txt{'06'}</td>
</tr>~;

        foreach my $award (sort { $a <=> $b } @mem_awards) {
            chomp $award;
            ($award_order, $award_id, $award_title, $award_image, $award_desc) = split /[|]/xsm, $award;
             $show_awards .=qq~
<tr class="windowbg2">
    <td>$award_id</td>
    <td>$award_title</td>
    <td><img src="$modimgurl/Awards/$award_image" alt="$award_title" title="$award_title" /></td>
    <td>$award_desc</td>
    <td>$award_order</td>
    <td>[<a href="$adminurl?action=awards_edit;id=$award_id">$award_txt{'19'}</a>]&nbsp;[<a href="$adminurl?action=awards_delete;id=$award_id" onclick="return confirm('$award_txt{'17'}\\n\\n$award_txt{'28'}');">$award_txt{'18'}</a>]</td>
</tr>~;
        }
    } else {
        $show_awards .=qq~
<tr class="windowbg2">
    <td>$award_txt{'29'}</td>
</tr>~;
    }

    $yymain = qq~
<form action="$adminurl?action=awards2" method="post">
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <colgroup>
            <col width="50%" />
            <col width="50%" />
        </colgroup>
        <tr>
            <th style="text-align: left;" class="titlebg" colspan="2"><img src="$imagesdir/profile.gif" alt="" /> $award_txt{'30'}</th>
        </tr><tr>
            <td class="windowbg2"><label for="en_awards">$award_txt{'21'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="en_awards" id="en_awards" value="1"$chk_awards /></td>
        </tr><tr>
            <td class="windowbg2"><label for="en_awards_gmod">$award_txt{'22'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="en_awards_gmod" id="en_awards_gmod" value="1"$chk_awards_gmod /></td>
        </tr><tr>
            <td class="windowbg2"><label for="en_awards_tab">$award_txt{'23'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="en_awards_tab" id="en_awards_tab" value="1"$chk_awards_tab /></td>
        </tr><tr>
            <td class="windowbg2"><label for="en_awards_mv">$award_txt{'24'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="en_awards_mv" id="en_awards_mv" value="1"$chk_awards_mv /></td>
        </tr><tr>
            <td class="windowbg2"><label for="awards_name">$award_txt{'25'}:</label></td>
            <td class="windowbg2"><input type="text" size="35" name="awards_name" id="awards_name" value="$awards_name" /></td>
        </tr><tr>
            <td class="windowbg2"><label for="en_awards_im">$award_txt{'41'}</label></td>
            <td class="windowbg2"><input type="checkbox" name="en_awards_im" id="en_awards_im" value="1"$chk_awards_im /></td>
        </tr><tr>
            <td class="windowbg2"><label for="awards_imsubject">$award_txt{'42'}:</label></td>
            <td class="windowbg2"><input type="text" size="35" name="awards_imsubject" id="awards_imsubject" value="$awards_imsubject" /></td>
        </tr><tr>
            <td class="windowbg2"><label for="awards_imtext">$award_txt{'43'}:<br /><span class="small">$award_txt{'46'}:<br />{name} - $award_txt{'47'}<br />{award} - $award_txt{'48'}<br />{reason} - $award_txt{'49'}<br />{myname} - $award_txt{'50'}<br />{mbname} - $award_txt{'51'}</span></label></td>
            <td class="windowbg2"><textarea name="awards_imtext" id="awards_imtext" cols="35" rows="7">$awards_imtext</textarea></td>
        </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <th class="titlebg"><img src="$imagesdir/preferences.gif" alt="" /> $admin_txt{'10'}</th>
            </tr><tr>
                <td class="catbg center"><input class="button" type="submit" value="$admin_txt{'10'}" /></td>
            </tr>
        </table>
    </div>
</form>
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <tr>
            <th class="titlebg" style="text-align: left;" colspan="6"><img src="$imagesdir/profile.gif" border="0" alt="" style="vertical-align: middle;" /> $award_txt{'31'} ($total_awards)</th>
        </tr>
$show_awards
    </table>
</div>
<form action="$adminurl?action=awards_add" method="post">
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <colgroup>
            <col width="25%" />
            <col width="75%" />
        </colgroup>
        <tr>
        <th class="titlebg" style="text-align: left;" colspan="2"><img src="$imagesdir/profile.gif" alt="" /> $award_txt{'32'}</th>
        </tr><tr>
            <td  class="windowbg2"><label for="award_id"><span style="font-weight: bold;">$award_txt{'26'}:</span><br /><span class="small">$award_txt{'33'}</span></label></td>
            <td  class="windowbg2"><input type="text" name="award_id" id="award_id" size="35" /></td>
        </tr><tr>
            <td  class="windowbg2"><label for="award_title"><span style="font-weight: bold;">$award_txt{'02'}:</span><br /><span class="small">$award_txt{'34'}</span></label></td>
            <td  class="windowbg2"><input type="text" name="award_title" id="award_title" size="35" /></td>
        </tr><tr>
            <td  class="windowbg2"><label for="award_image"><span style="font-weight: bold;">$award_txt{'01'}:</span><br /><span class="small">$award_txt{'35'}</span></label></td>
            <td  class="windowbg2"><input type="text" name="award_image" id="award_image" size="35" /></td>
        </tr><tr>
            <td  class="windowbg2"><label for="award_desc"><span style="font-weight: bold;">$award_txt{'07'}:</span><br /><span class="small">$award_txt{'36'}</span></label></td>
            <td  class="windowbg2"><input type="text" name="award_desc" id="award_desc" size="70" /></td>
        </tr><tr>
            <td  class="windowbg2"><label for="award_order"><span style="font-weight: bold;">$award_txt{'27'}:</span><br /><span class="small">$award_txt{'37'}</span></label></td>
            <td  class="windowbg2"><input type="text" name="award_order" id="award_order" size="3" /></td>
        </tr>
    </table>
</div>
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <tr>
            <th class="titlebg"><img src="$imagesdir/preferences.gif" alt="" /> $admin_txt{'10'}</th>
        </tr><tr>
            <td class="catbg center"><input class="button" type="submit" value="$award_txt{'38'}" /></td>
        </tr>
    </table>
</div>
</form>
~;

    $yytitle = $mod_list{'awards1'};
    $action_area = "awards";
    AdminTemplate();
    exit;

}

sub Awards2 {
    is_admin_or_gmod();

    $en_awards        = $FORM{'en_awards'} || '0';
    $en_awards_gmod   = $FORM{'en_awards_gmod'} || '0';
    $en_awards_tab    = $FORM{'en_awards_tab'} || '0';
    $en_awards_mv     = $FORM{'en_awards_mv'} || '0';
    $awards_name      = $FORM{'awards_name'};
    $en_awards_im     = $FORM{'en_awards_im'} || '0';
    $awards_imsubject = $FORM{'awards_imsubject'};
    $awards_imtext    = $FORM{'awards_imtext'};
    $awards_imtext    =~ s/\r(?=\n*)//gxsm;
    $awards_imtext    =~ s~\n~<br />~gxsm;

    my $setfile = << "EOF";
###############################################################################
# AwardSettings.txt (Member Awards configurations)                            #
###############################################################################

\$en_awards = $en_awards; # Enable Member Awards
\$en_awards_gmod = $en_awards_gmod; # Enable GMods to issue Member Awards
\$en_awards_tab = $en_awards_tab; # Show Awards in tab menu
\$en_awards_mv = $en_awards_mv; # Show Awards in message view
\$awards_name = "\Q$awards_name\E"; # Set the Awards name
\$en_awards_im = $en_awards_im; # Enable automatic PM
\$awards_imsubject= "\Q$awards_imsubject\E"; # Set the PM subject
\$awards_imtext = "\Q$awards_imtext\E"; # Set the PM message

1;
EOF

    fopen(FILE, ">$vardir/Mods/AwardSettings.txt");
    print FILE $setfile;
    fclose(FILE);

    require Admin::NewSettings;
    SaveSettingsTo('Settings.pm');

    if ($action eq 'awards2') {
        $yySetLocation = qq~$adminurl?action=awards~;
        redirectexit();
    }
}

sub AddAward {
    is_admin_or_gmod();

    $award_id    = $FORM{'award_id'};
    $award_title = $FORM{'award_title'};
    $award_image = $FORM{'award_image'};
    $award_desc  = $FORM{'award_desc'};
    $award_order = $FORM{'award_order'};

    if ($award_id    eq q{}) { fatal_error('no_value',"$award_txt{'26'}"); }
    if ($award_title eq q{}) { fatal_error('no_value',"$award_txt{'02'}"); }
    if ($award_image eq q{}) { fatal_error('no_value',"$award_txt{'01'}"); }
    if ($award_desc  eq q{}) { fatal_error('no_value',"$award_txt{'07'}"); }
    if ($award_order eq q{}) { fatal_error('no_value',"$award_txt{'27'}"); }

    fopen(AWARDS, ">>$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    print AWARDS "$award_order|$award_id|$award_title|$award_image|$award_desc\n";
    fclose(AWARDS);

    if ($action eq 'awards_add') {
        $yySetLocation = qq~$adminurl?action=awards~;
        redirectexit();
    }
}

sub DeleteAward {
    is_admin_or_gmod();

    fopen(AWARDS, "<$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    @mem_awards = <AWARDS>;
    fclose(AWARDS);

    fopen(AWARDS, ">$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    print AWARDS grep (!/\b$INFO{'id'}\b/, @mem_awards);
    fclose(AWARDS);

    if ($action eq 'awards_delete') {
        $yySetLocation = qq~$adminurl?action=awards~;
        redirectexit();
    }
}

sub EditAward {
    is_admin_or_gmod();

    $id = $INFO{'id'};
    my $award_edit = q{};

    fopen(AWARDS, "<$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    @mem_awards = <AWARDS>;
    fclose(AWARDS);

    for my $award (@mem_awards) {
        chomp $award;
        if ($award =~ /\b$id\b/) {
            $award_edit = $award; last;
        }
    }
    ($award_order, $award_id, $award_title, $award_image, $award_desc) = split /[|]/xsm, $award_edit;

    $yymain = qq~
<form action="$adminurl?action=awards_edit2" method="post">
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <colgroup>
            <col width="25%" />
            <col width="75%" />
        </colgroup>
        <tr>
            <th class="titlebg" colspan="2"><img src="$imagesdir/profile.gif" /> $award_txt{'40'}</th>
        </tr><tr>
            <td class="windowbg2"><label for="award_id"><span style="font-weight: bold;">$award_txt{'26'}:</span></label></td>
            <td class="windowbg2"><input type="hidden" name="award_id" id="award_id" value="$award_id" />$award_id</td>
        </tr><tr>
            <td class="windowbg2"><label for="award_title"><span style="font-weight: bold;">$award_txt{'02'}:</span><br /><span class="small">$award_txt{'34'}</span></label></td>
            <td class="windowbg2"><input type="text" name="award_title" id="award_title" size="35" value="$award_title" /></td>
        </tr><tr>
            <td class="windowbg2"><label for="award_image"><span style="font-weight: bold;">$award_txt{'01'}:</span><br /><span class="small">$award_txt{'35'}</span></label></td>
            <td class="windowbg2"><input type="text" name="award_image" id="award_image" size="35" value="$award_image" /></td>
        </tr><tr>
            <td class="windowbg2"><label for="award_desc"><span style="font-weight: bold;">$award_txt{'07'}:</span><br /><span class="small">$award_txt{'36'}</span></label></td>
            <td class="windowbg2"><input type="text" name="award_desc" id="award_desc" size="70" value="$award_desc" /></td>
        </tr><tr>
            <td class="windowbg2"><label for="award_order"><span style="font-weight: bold;">$award_txt{'27'}:</span><br /><span class="small">$award_txt{'37'}</span></label></td>
            <td class="windowbg2"><input type="text" name="award_order" id="award_order" size="3" value="$award_order" /></td>
        </tr>
    </table>
</div>
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <tr>
            <th class="titlebg"><img src="$imagesdir/preferences.gif" alt="" /> $admin_txt{'10'}</th>
        </tr><tr>
            <td class="catbg center"><input class="button" type="submit" value="$admin_txt{'10'}" />&nbsp;<input type="button" class="button" value="$award_txt{'12'}" onclick="location.href='$adminurl?action=awards';" /></td>
        </tr>
    </table>
</div>
</form>~;

    $yytitle = $mod_list{'awards1'};
    AdminTemplate();
    exit;

}

sub EditAward2 {
    is_admin_or_gmod();

    $award_id    = $FORM{'award_id'};
    $award_title = $FORM{'award_title'};
    $award_image = $FORM{'award_image'};
    $award_desc  = $FORM{'award_desc'};
    $award_order = $FORM{'award_order'};

    if ($award_title eq q{}) { fatal_error('no_value',"$award_txt{'02'}"); }
    if ($award_image eq q{}) { fatal_error('no_value',"$award_txt{'01'}"); }
    if ($award_desc  eq q{}) { fatal_error('no_value',"$award_txt{'07'}"); }
    if ($award_order eq q{}) { fatal_error('no_value',"$award_txt{'27'}"); }

    fopen(AWARDS, "<$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    @mem_awards = <AWARDS>;
    fclose(AWARDS);

    @award = grep (!/\b$award_id\b/, @mem_awards);
    push @award, "$award_order|$award_id|$award_title|$award_image|$award_desc";
    $award = join(q{}, @award);

    fopen(AWARDS, ">$vardir/Mods/Awards.txt") || fatal_error('cannot_open',"$vardir/Mods/Awards.txt", 1);
    print AWARDS "$award\n";
    fclose(AWARDS);

    if ($action eq 'awards_edit2') {
        $yySetLocation = qq~$adminurl?action=awards~;
        redirectexit();
    }
}

1;